Microsoft Data Access Components (MDAC)

MDAC Start Page

MDAC
Version 2.7

[This is preliminary documentation and subject to change.]

Purpose

The Microsoft® Data Access Components (MDAC) SDK documents the key technologies that enable Universal Data Access, Microsoft's strategy for providing access to information across the enterprise.

Microsoft Data Access Components include ActiveX® Data Objects (ADO), OLE DB, and Open Database Connectivity (ODBC). Data-driven client/server applications deployed over the Web or a LAN can use these components to easily integrate information from a variety of sources, both relational (SQL) and nonrelational.

The MDAC SDK is the primary source of information and instruction for using data access technologies. Its tools, samples, and documentation are designed to help developers create solutions for their data access needs.

For the latest news about MDAC technologies, see the Microsoft Universal Data Access Web site.

If you have questions or need detailed information about properly redistributing MDAC, see "Redistributing MDAC" for a description of the distribution requirements for MDAC.

ActiveX Data Objects (ADO)

Microsoft ActiveX Data Objects (ADO) provides consistent, high-performance access to data and supports a variety of development needs, including the creation of front-end database clients and middle-tier business objects that use applications, tools, languages, or Internet browsers. The primary benefits of ADO are ease of use, high speed, low memory overhead, and a small disk footprint.

ADO provides an easy-to-use interface to OLE DB, which provides the underlying access to data. It uses a familiar metaphor—the COM Automation interface—available from all leading Rapid Application Development (RAD) tools, database tools, and languages.

OLE DB

Microsoft OLE DB is a set of interfaces that expose data from a variety of relational and nonrelational sources by using the Component Object Model (COM). OLE DB interfaces provide applications with uniform access to data stored in diverse information sources. These interfaces support the amount of DBMS functionality appropriate to the data store, enabling the data store to share its data.

OLE DB comprises a programmatic model consisting of data providers, which contain and expose data; data consumers, which use data; and service components, which process and transport data (such as query processors and cursor engines). In addition, OLE DB includes a bridge to ODBC to enable continued support for the broad range of ODBC relational database drivers.

Open Database Connectivity (ODBC)

The Microsoft Open Database Connectivity (ODBC) interface makes it possible for applications to access data from a variety of DBMSs. ODBC permits maximum interoperability—an application can access data in diverse DBMSs through a single interface. Furthermore, that application will be independent of any DBMS from which it accesses data. Users of the application can add software components called drivers, which create an interface between an application and a specific DBMS.

Main Components of MDAC 2.7

Microsoft ActiveX Data Objects (ADO)

This section contains Programmer's References for ADO, ADOX, ADO MD, and Remote Data Service (RDS), as well as samples documentation.

Microsoft OLE DB

This section documents the OLE DB and OLE DB for OLAP interfaces, including a Programmer's Reference, documentation for various OLE DB providers, and samples.

Microsoft Open Database Connectivity (ODBC)

This section documents the ODBC interface, including a Programmer's Reference, documentation for various ODBC drivers, and samples.

Microsoft Data Access Technical Articles

Microsoft Data Access Technical Articles

This section addresses cross-technology and overview topics, including the latest information about MDAC SDK component technologies.

Component Checker

The Component Checker is designed to determine and diagnose installation issues with MDAC components. It is available from www.microsoft.com/data. The self-extracting .exe file contains all installation files for the tool to operate properly. Furthermore, it is customizable and performs the following tasks:

  • Identifies the current MDAC installation on a computer.
  • Creates a series of reports about the files identified for the current MDAC installation.
  • Removes existing MDAC installations after listing .dll conflicts and identifying programs that reference a given .dll.

Feedback

You can send feedback about the MDAC documentation or samples directly to the MDAC documentation team.


What's New in the MDAC SDK

[This is preliminary documentation and subject to change.]

The Microsoft Data Access Components are now integrated into Microsoft Windows® 2000 as system-level components. This means that beginning with Windows 2000, MDAC is part of the base operating system installation.

The following topics highlight important changes in the MDAC documentation since the last version (MDAC 2.6) release, provide general information about overall areas of interest, and refer you to documents and Web pages where you can get more detailed information about Microsoft's data access strategies:

  • Changes and Enhancements in MDAC 2.7 is an overview with links to more specific information about what has changed since the MDAC 2.5 SDK.
  • Do You Have Feedback About MDAC Documentation? offers tips on how to send feedback directly to the MDAC documentation team.
  • Microsoft Data Access Web Site provides links to technologies that work with MDAC.


Changes and Enhancements in MDAC 2.6

For more detailed information about what is new and changed in specific MDAC technologies, see the following topics:

  • What's New in ADO
  • What's New in OLE DB
  • What's New in ODBC


Navigating the MDAC Documentation

This chart is designed to guide you through the Microsoft® Data Access Components (MDAC) documentation. Look on the chart to find MDAC information about what you want to learn, the problem you want to solve, or an activity you want to do. For a better understanding of MDAC technologies, we recommend that everyone read the "What Are the MDAC Technologies?" technical article at the Microsoft Universal Data Access Web site.

Tasks | Go To | Language
Learn about data access technologies |  |
Novice | Microsoft Data Access Components overview "MDAC Technology Features" technical article "Choosing MDAC Components" technical article ActiveX Data Objects (ADO) overview OLE DB overview Open Database Connectivity (ODBC) overview |
Experienced with RDO/DAO or PowerBuilder/Delphi Tools | "Migrating from DAO to ADO" technical article |
Use Visual Basic to create an application that uses data accessed from different data stores | ADO overview | Visual Basic
Use a browser to create an application that uses data accessed from different data stores | ADO overview ADO Samples | Active Server Pages
Expose multidimensional data using ADO | ADO MD | Visual Basic, Visual C++, Visual J++
Expose data and services through OLE DB |  |
OLE DB novice | OLE DB overview OLE DB Samples OLE DB Programmer's Reference OLE DB Simple Provider Toolkit | Visual Basic, Visual C++, Visual J++
OLE DB expert | "OLE DB Minimum Levels of Consumer and Provider Functionality" technical article OLE DB Providers OLE DB Programmer's Reference OLE DB Testing | Visual C++
Use multidimensional data | OLE DB for Online Analytical Processing (OLAP) |
Expose SQL data through ODBC | ODBC overview "OLE DB for the ODBC Programmer" technical article |


Locating MDAC Components

Installing MDAC 2.7

Beginning with MDAC 2.5, MDAC core components were integrated with the Windows® 2000 operating system. Overwriting some of these system files is prohibited. The version of MDAC included with Windows 2000 can only be updated by an operating system update or certain products including SQL Server 2000. Installing SQL Server 2000 will install MDAC 2.6 on the computer.

The MDAC Redist (MDAC_TYP.EXE) overwrites any existing MDAC files on computers running Microsoft Windows NT® 4.0 or Windows 95/98.

Installing the Data Access SDK from www.microsoft.com/data

The 2.7 SDK is available in 2 forms - a standalone executable and as part of an upcoming release of the Microsoft Platform SDK.

The standalone 2.7 SDK will be available from the Microsoft Data Access website. Point your browser to http://www.microsoft.com/data and select "Downloads."

Installing the Platform SDK from MSDN Online

The Data Access SDK is also included in the Platform SDK. The Spring 2001 Platform SDK will include MDAC 2.7 SDK. The Fall or Winter 2000 Platform SDK release contains the MDAC 2.6 SDK. Prior releases of the platform SDK contain the MDAC 2.5 SDK. For information about installing the Platform SDK, see the Products page of the MSDN Online Web site at http://msdn.microsoft.com. If you customize your installation of the Platform SDK, be aware that links to some components might not function.

Directory Structure

The Platform SDK setup process installs into:

C:\Program Files\Microsoft Data Access SDK

This directory can be changed by selecting "Custom" install from the setup program.

The following directories are created during installation. Depending on the components you select during installation, your directory structure might vary.

Directory | Description
Docs | Documentation and Help files.
Inc | Header files for MDAC SDK components.
IDL | Interface Definition files for generating headers, typelibs, etc.
Lib | Library files for MDAC SDK components.
Conformance Tests | Conformance tests and tools.
Samples | ADO, OLE DB and ODBC sample applications.


Using MDAC Resources

This section discusses a variety of resources for finding information about the MDAC SDK:

  • MDAC Documentation
  • User Interface Help
  • MDAC Samples
  • Web Sites
  • Microsoft Knowledge Base Articles
  • Printed Resources


MDAC Documentation

The MDAC documentation includes ActiveX Data Objects (ADO), OLE DB, ODBC, and MDAC technical articles. Each section is included within the Data Access SDK and also is available through MSDN Online.

For late-breaking information about the MDAC components and documentation, see the MDAC SDK Readme. To view this file, point to Start, Programs, Microsoft Data Access SDK, and then click MDAC SDK Readme, or search for MDACSDK26Readme.htm on your computer.

Documentation for MDAC is not available in print.

HTML Help

MDAC documentation is presented in HTML Help. The following illustration describes some of the features of HTML Help and provides suggestions for its use. For more information about using the Search feature, see the advanced full-text search document.


User Interface Help

Detailed help for the following components is available from their individual Help menus or dialog boxes. The following sections of the MDAC documentation include general information about each component:

  • ODBC Data Source Administrator
  • ODBC Driver for Oracle
  • ODBC Test
  • Data Link API
  • Local Test Manager


MDAC Samples

As MDAC technologies change to reflect business and developer demands, the number and type of samples also change. The following sections of the MDAC documentation discuss in detail some sample applications using MDAC technologies:

  • ADO Samples
  • OLE DB Samples
  • ODBC Samples


Web Sites

Universal Data Access

The Universal Data Access Web site at http://www.microsoft.com/data contains current information specific to the MDAC technologies: ADO, OLE DB, and ODBC. On this site, you will find discussions of current issues, release manifests, downloads, and links to related technologies and sites.

MSDN Online

The MSDN Online Web site at http://msdn.microsoft.com offers a wide range of developer resources for finding help on specific topics. This site also contains the Platform SDK.

Using the MSDN Online Search feature, you can access the Knowledge Base, Web Workshop, product information, documentation, and other resources.


Microsoft Knowledge Base Articles

Microsoft Knowledge Base articles, available at http://msdn.microsoft.com, contain specific solutions, workarounds, and pertinent information about the MDAC SDK. The following table includes helpful keywords to use when searching the Knowledge Base for assistance with MDAC technologies.

Technology | Keywords
MDAC MDAC SDK | kbgrpMDAC kbMDAC kbMDAC200 kbMDAC210 kbMDAC250 kbSDKDataAc kbDatabase
ADO RDS | kbADO kbADO150 kbADO200 kbADO210 kbADO250 kbRDS
OLE DB | kbOLEDB kbOLEDB200 kbOLEDB210 kbOLEDB250
OLE DB providers | kbProvider
OSP Toolkit | kbOSP
ODBC | kbODBC odbcAPI kbODBC200 kbODBC250 kbODBC351 kb32bitonly odbcGPF
ODBC Desktop Database Drivers | kbDriver kbJet odbcExcel
ODBC Driver for Oracle | kbOracle kb3rdParty odbcOracle kbOracle200
Visual FoxPro ODBC Driver | kbgrpFox
SQL ODBC Driver and OLE DB Provider for SQL Server | kbSQL kbSQLServ kbSQLServ650 kbSQLServ700


Printed Resources

Microsoft Press publishes a number of guides and reference books that are useful when developing applications using MDAC technologies. Other printed resources are available from technical book publishers.

For a complete list of publications, see the Microsoft Press Web site at http://mspress.microsoft.com or see the Resources section of the MSDN Online Web site at http://msdn.microsoft.com.


Redistributing MDAC

Each release of MDAC includes a matched set of modules. These modules were tested together when they were released by Microsoft. The interdependencies of the modules are not simple; they must all be distributed as a set. Although it's tempting to try to distribute only the modules for the components that you think your application may need, there is no supported way to do that. Other applications will use MDAC components, and if they aren't part of the same released set, the applications will probably crash.

Note Each release of MDAC includes a license agreement, which gives you specific rights to redistribute some of the files in MDAC. This article does not change the terms of the license agreements in any way.

The current version of MDAC includes a redistributable MDAC setup, in the file mdac_typ.exe. This program is a self-extracting compressed file that installs the run-time components onto a workstation.

The ADO components (including RDS) and some OLE DB modules require administrator privileges on Microsoft Windows NT® and Microsoft Windows® 2000 to install and register correctly.

For MDAC 2.7, the redistributable MDAC setup program was designed to install on these platforms:

  • Windows 95 with DCOM95 installed (see the Knowledge Base article "Q191094: MDAC 2.0 Requires DCOM95 to Install Under Windows 95"
  • Windows 98 (all editions)
  • Windows NT 4.0 with Internet Explorer 4.01 or later installed

See the Microsoft Universal Data Access Web site (http://www.microsoft.com/data) for more information on redistributing MDAC 2.7.

Avoiding a Restart

The redistributable MDAC setup will sometimes require the workstation to be restarted to complete its installation. In some situations, however, it may be possible to avoid restarting the workstation. Shutting down applications and services that are using MDAC components will minimize the likelihood that the redistributable setup will try to restart the workstation to complete the installation.

Starting with MDAC 2.6 the setup program will try to detect if any of the files it will be installing are in use and raise a dialog to inform the user of this. This will allow the user to try and shut down those applications in order to try to reduce the need for a reboot.

The procedures for shutting down applications are generally obvious and simple. However, shutting down system services, which are applications that run in a special context for the operating system, is not as obvious or intuitive. Use the Services applet in the Windows Control Panel to shut down running services. There are several services that may use MDAC components and should be stopped in order to install the MDAC components without restarting the workstation. For example, Internet Information Services (IIS), Component Services (formerly Microsoft Transaction Services MTS), and Microsoft® SQL Server™ are all services that may use MDAC components.

If the redistributable MDAC setup is being run as part of a larger installation, see the section below titled "Silent Setup," which shows the command switches used to prevent the MDAC setup from restarting the workstation immediately. Note that this does not eliminate the potential need to restart the workstation; if you do prevent the MDAC setup from restarting the workstation, you should assume that the installation will not be complete until the workstation is restarted.

MDAC setup has several modes to customize installation.

Standard Setup

Standard setup is the recommended mode. This mode emphasizes the fact that the user's system is being upgraded and offers the option to abort the installation if necessary. A setup may also involve restarting the machine, and this method gives users maximum control over the timing of the restart.

To run MDAC setup in standard mode, simply execute mdac_typ.exe with no command-line parameters. This will bring up all necessary user interface dialogs to allow the user to install MDAC.

MDAC setup will extract all of the files in mdac_typ.exe to the user's TEMP directory. From there, it will run the setup program dasetup.exe. The setup program will display the license agreement, which the user must accept in order to proceed. Then the user will have two options: either select a complete installation of MDAC or exit the setup program. After the files are copied, the user will be notified if the workstation must be restarted. The user can choose to restart immediately or wait until later.

File Extraction

In this mode, MDAC setup merely extracts all of the files in mdac_typ.exe to a folder and then exits. It does not install MDAC. To run MDAC setup in file extraction mode, use the following syntax at the command prompt:

   mdac_typ /C /T:<full path>

For example, to extract all of the files in mdac_typ.exe to the folder "C:\MDAC FILES", use the following command:

   mdac_typ /C /T:"C:\MDAC FILES"

You do not have to create the folder before extracting files to it. MDAC setup will create the folder for you if it doesn't exist.

This is also not a "silent" setup; all of the files will be copied to the folder provided. The user will see a window indicating that the files are being copied. After the files are all copied, all processing stops and no setup is run.

Logging

MDAC setup will create a log file in the Windows root directory. This file is DASETUP.LOG it details the actions that setup ran and the result of the setup.

Silent Setup

This mode installs MDAC with almost no visible user interface at all. This mode should be used only as part of a larger application setup program that can handle any problems that may arise during installation. To run MDAC setup in silent mode, use the following command:

   mdac_typ /Q:A /C:"dasetup /Q"

If you need to prevent the MDAC setup from restarting the workstation, use this command:

   mdac_typ /Q:A /C:"dasetup /Q /N"

For MDAC 2.6, and later, we also added Files in use detection to the setup. You can run a silent setup that will raise a dialog if setup finds any MDAC files in use to give the user the chance to shut those applications down with the following command line

   mdac_typ /Q:A /C:"dasetup /Q:D /N"

This will completely install MDAC but will not restart the workstation. A restart may be required to complete the installation, so the larger application setup program should restart when it has completed its setup.

The Knowledge Base article "Q192009 - HOWTO: Invoke Silent MDAC or DA SDK 2.0 Redistribution" also has information about options you can use with the MDAC setup program.

Manual Setup

Microsoft does not recommend or support manual setup of the MDAC files. Use only the redistributable program mdac_typ.exe to distribute MDAC, in accordance with the license agreement.

ODBC Notes

In general, it is safe to mix and match ODBC drivers with ODBC Driver Manager/Core Components. You should make sure the ODBC Driver Manager is more recent than the ODBC drivers, even though the product group attempts to ensure that the ODBC Driver Manager and Microsoft ODBC drivers are backward compatible.


Troubleshooting

When you have trouble with MDAC technologies, try the following resources to get help before calling Microsoft Product Support Services.

  • MDAC Technical Articles You can find a number of technical articles pertaining to MDAC in the Platform SDK.
  • Web Sites The Universal Data Access Web site and MSDN Library provide articles and technical information that may help you.
  • Microsoft Knowledge Base The articles in this database provide specific solutions, workarounds, and pertinent information about the Microsoft Data Access Components.
  • Public newsgroups: microsoft.public.data.ado and others.


Getting Help from Microsoft Product Support Services

If you can't find the answers you need in the Microsoft Data Access Components (MDAC) documentation, you can resolve problems quickly by accessing the Microsoft Product Support Services Web site at http://www.microsoft.com/support.

For additional technical resources and information about developing with Microsoft products and technologies, visit MSDN Online at http://msdn.microsoft.com.


Do You Have Feedback About MDAC Documentation?

The MDAC documentation team welcomes your suggestions and comments about our documentation and samples. You can send feedback quickly and directly to us via e-mail or the Universal Data Access Web site. Many of your suggestions have been implemented in this release of the documentation.

Note If you need technical support, see "Getting Help from Microsoft Product Support Services." The MDAC documentation team cannot answer technical support questions, but we welcome your feedback concerning the presentation, accuracy, and thoroughness of the documentation, as well as your ideas for improving it.

E-mail

The MDAC documentation now includes a Documentation Feedback button at the top of every topic. Clicking this button offers an easy way to send e-mail feedback to the MDAC documentation team. Addresses for each section of the MDAC documentation also appear below.

Documentation | Address
MDAC Overview | mdacdoc@microsoft.com
ADO | adodoc@microsoft.com
OLE DB and providers | oledbdoc@microsoft.com
ODBC and drivers | odbcdoc@microsoft.com
MDAC technical articles | datech@microsoft.com
MDAC samples | dacode@microsoft.com

Universal Data Access Web site

For product or documentation feedback, use the form at the Universal Data Access Web site. This form is specifically intended for feedback about the Web site, but any documentation and samples issues will be forwarded to the appropriate team.


MDAC Copyright and Legal Information

Information in this document is subject to change without notice. The names of companies, products, people, characters, and/or data mentioned herein are fictitious and are in no way intended to represent any real individual, company, product, or event, unless otherwise noted. Complying with all applicable copyright laws is the responsibility of the user. No part of this document may be reproduced or transmitted in any form or by any means, electronic or mechanical, for any purpose, without the express written permission of Microsoft Corporation. If, however, your only means of access is electronic, permission to print one copy is hereby granted.

Microsoft may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except as expressly provided in any written license agreement from Microsoft, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

Microsoft, ActiveX, BackOffice, Developer Studio, FoxPro, JScript, Microsoft Press, MSDN, MS-DOS, PivotTable, Visual Basic, Visual C++, Visual InterDev, Visual J++, Visual Studio, Win32, Windows, and Windows NT are either registered trademarks or trademarks of Microsoft Corporation in the United States and/or other countries.

Apple and Macintosh are registered trademarks of Apple Computer, Inc.

Intel is a registered trademark of Intel Corporation.

Other product and company names mentioned herein may be the trademarks of their respective owners.


About Advanced Full-Text Search

Advanced full-text search allows you to search using Boolean, wildcard, and nested expressions. You can also limit the search to previous results, match similar words, or search topic titles only.

Click the following links to learn more about full-text search:

  • Focusing Your Search
  • Searching for Help Topics
  • Finding Information Using Advanced Full-Text Search
  • Searching for Words or Phrases
  • Defining Search Terms
  • Using Nested Expressions When Searching

Focusing Your Search

When an entire collection of documents is accessible through HTML Help (as evidenced by the Define Subset option on the View menu), searching can produce too many results. To restrict the index and search results, define a subset to your current collection.

To define a subset:

  1. On the View menu, choose Define Subset. The Define Subset dialog box appears.
  2. From the list of available items presented in the left hand pane, select those that you want to be included in the new subset. Use the Add and Remove buttons to build the subset.
  3. When your subset of help topics is complete, type in a name in the Save new subset as box and click Save.
  4. Return to HTML Help and select the subset in the Active Subset box.

You can modify a subset at anytime by using the Define Subset menu item.

Searching for Help Topics

A basic search consists of the word or phrase you want to find. You can use wildcard expressions, nested expressions, Boolean operators, similar word matches, a previous results list, or topic titles to further define your search.

The basic rules for formulating queries are as follows:

  • Searches are not case-sensitive, so you can type your search in uppercase or lowercase characters.
  • You can search for any combination of letters (a-z) and numbers (0-9).
  • Punctuation marks such as the period, colon, semicolon, and comma are ignored during a search.
  • Hyphens used in the search string are treated as a word break and return results differently than other punctuation remarks. For example, the search phrase "forward-only" will return results matching "forward-only" and "only" but not "forward". The phrase "-only" returns "-only" and "only".
  • The period, when used in a numeric string, is treated as a decimal and the number is returned. For example "2.6.2345.2", will return the instances of the number, and "version 2.6" will return only the quoted string. When mixing characters and numbers without quotation marks, all combinations are returned.
  • Group the elements of your search using double quotes or parentheses to set apart each element. You cannot search for quotation marks.
    Note If you are searching for a file name with an extension, you should group the entire string in double quotes, like so: "filename.ext". Otherwise, the period will break the file name into two separate terms.

Return to top of page

Finding Information Using Advanced Full-Text Search

  1. Click the Search tab, and then type the word or phrase you want to find.
  2. Click the arrow button to add a Boolean operator (AND, OR, NEAR, NOT) to your search.
  3. Click List Topics and then double-click the topic you want to view, or select the desired topic and click Display.
  4. To sort the topic list, click the Title, Location, or Rank column heading.

Notes

  • You can precisely define a search by using wildcard expressions, nested expressions, and Boolean operators.
  • You can request similar word matches, search only the topic titles, or search the results of a previous search.

Return to top of page

Searching for Words or Phrases

You can search for words or phrases and use wildcard expressions. These expressions allow you to search for one or more characters by using a question mark (?) or asterisk (*). The following table describes the results of different kinds of searches.

Search | Example | Results
For a single word | select | Topics that contain the word "select." (You will also find grammatical variations, such as "selector" and "selection.")
For a phrase | "new operator" -or- new operator | Topics that contain the literal phrase "new operator" and all its grammatical variations. Without the quotation marks, the query is equivalent to specifying "new AND operator," which will find topics containing both of the individual words, instead of the designated phrase.
Using wildcard expressions | esc* -or- 80?86 | Topics that contain the terms "ESC," "escape," "escalation," and so on. The asterisk cannot be the only character in the term. Topics that contain the terms "80186," "80286," "80386," and so on. The question mark cannot be the only character in the term.

Note Select the Match similar words check box at the bottom of the pane to return minor grammatical variations of a phrase.

Return to top of page

Defining Search Terms

The AND, OR, NOT, and NEAR operators enable you to precisely define your search by creating a relationship between search terms. The following table shows how you can use each of these operators. If no operator is specified, AND is used. For example, the query "spacing border printing" (typed without quotes) is equivalent to "spacing AND border AND printing."

Search for | Example | Results
Both terms in the same topic | dib AND palette | Topics containing both the words "dib" and "palette."
Either term in a topic | raster OR vector | Topics containing either the word "raster" or the word "vector" or both.
The first term without the second term | ole NOT dde | Topics containing the term "OLE," but not the term "DDE."
Both terms in the same topic, close together | user NEAR kernel | Topics containing the word "user" within eight words of the word "kernel."

Note The |, &, and ! characters don't work as Boolean operators. You must use OR, AND, and NOT.

Return to top of page

Using Nested Expressions When Searching

Nested expressions allow you to create complex searches for information. For example, "control AND ((active OR dde) NEAR window)" finds topics containing the word "control" along with the words "active" and "window" close together, or containing "control" along with the terms "DDE" and "window" close together.

The basic rules for searching help topics using nested expressions are as follows:

  • You can use parentheses to nest expressions within a query. The expressions in parentheses are evaluated before the rest of the query.
  • If a query does not contain a nested expression, it is evaluated from left to right. For example, "control NOT active OR dde" finds topics containing the word "control" without the word "active," or finds topics containing the term "DDE." On the other hand, "control NOT (active OR dde)" finds topics containing the word "control" without either of the terms "active" or "DDE."
  • You cannot nest expressions more than five levels deep.

Return to top of page